/* Specimen LASH/LADCCA support... */

#include "specimen.h"
/* need to load specimen.h first because it has the HAVE_LADCCA variable defined.... */

#ifdef HAVE_LADCCA

#include <stdio.h>
#include <ladcca/ladcca.h>
#include <glib.h>
#include <glib/gprintf.h>
#include "beef.h"
#include "gui/gui.h"		/* so we can update the gui when we load patches */

static cca_client_t *cca_client;

cca_client_t *leash_get_client ( )
{
     return cca_client;
}

int leash_init (cca_args_t * cca_args)
{
     cca_event_t *cca_event;
     int flags = CCA_Config_File;

     cca_client =
	  cca_init (cca_args, PACKAGE_NAME, flags, CCA_PROTOCOL (2, 0));

     if (cca_client)
     {
	  cca_event = cca_event_new_with_type (CCA_Client_Name);
	  cca_event_set_string (cca_event, "specimen");
	  cca_send_event (cca_client, cca_event);
     }

     return 0;
}

int leash_idle ( )
{
     cca_event_t *event;
     char *filename;

     while ((event = cca_get_event (cca_client)))
     {
	  switch (cca_event_get_type (event))
	  {
	  case CCA_Save_File:
	       filename =
		    g_strconcat (cca_event_get_string (event),
				 "/specimen.beef", NULL);
	       fprintf (stderr, "saving file %s \n", filename);
	       beef_write (filename);
	       cca_send_event (cca_client, event);
	       free (filename);
	       break;
	  case CCA_Restore_File:
	       /*putting the slashes in is just the easiest way OK? ;-) */
	       filename =
		    g_strconcat (cca_event_get_string (event),
				 "/specimen.beef", NULL);
	       fprintf (stderr, "restoring file %s \n", filename);
	       beef_read (filename);
	       update_interface_helper (0);	/*Show the loaded patches */
	       cca_send_event (cca_client, event);
	       free (filename);
	       break;
	  case CCA_Quit:
	       /* Should we do anything here? */
	       cca_event_destroy (event);
	       return 1;
	       break;
	  case CCA_Server_Lost:
	       fprintf (stderr, "server lost\n");
	       fprintf (stderr, "LADCCA server disconnected\n");
	       cca_event_destroy (event);
	       return 0;
	       break;
	  default:
	       fprintf (stderr, "Recieved LADCCA event of unknown type %d\n",
			cca_event_get_type (event));
	       cca_event_destroy (event);
	       break;
	  }
     }

     if (!cca_enabled (cca_client))
	  return 0;

     return 1;
}

#endif /* HAVE_LADCCA */
